//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
int main(int argc, char **argv)
{
  FILE *fp_src, *fp_dest;
  unsigned long fct_num, fct_count;
  int r;
  char Buffer[256];

  if ( (fp_src=fopen ( "exec.inc", "r" )) == NULL )
  {
    printf ( "\nERROR : Could not open exec.inc.\n\n" );
    return 0;
  }

  if ( (fp_dest=fopen ( "romcalls.h", "w" )) == NULL )
  {
    printf ( "\ERROR : Could not open output file romcalls.h for writing.\n\n" );
    fclose ( fp_src );
    return 0;
  }

  do {
    fscanf ( fp_src, "%s = %d", &Buffer, &fct_count);
  } while ( strcmp ( Buffer, "JUMP_TABLE_SIZE" ) != 0 );


  printf ( "\nProcessing...\n\n");
  
  fprintf ( fp_dest, ";--------------------------------------------------------------\n"
  					 "; TI-92+ ROM Entry Points\n;\n"
                     ";Created from the exec.inc file of Texas Instrument (c)\n"
                     ";Can be used with PlusShell or DoorsOS\n;\n"
                     "; Benoit SCHERRER  -  p.c.scherrer@wanadoo.fr\n"
                     ";--------------------------------------------------------------\n\n"
                     "JUMP_TABLE_SIZE\tequ\t%d\t\t;%x\n\n"
                     , fct_count, fct_count);


  do {
    fct_num = 0x0FFFFFFF;
    r = fscanf ( fp_src, "%s = %d", &Buffer, &fct_num);

    if ( strcmp ( Buffer, "" ) == 0 ) continue;
    if ( fct_num > fct_count*4 ) continue;


    fprintf ( fp_dest, ";--------------------------------------------------------------\n"
    				   "; Function : %s (  )\n;\n"
                       "; Use : \n;\n"
                       ";Input> \n"
                       ";Out>   \n"
                       ";--------------------------------------------------------------\n", Buffer );
    fprintf ( fp_dest, "doorsos::%s \tequ\t_ROM_CALL_%X\n", Buffer, fct_num/4 );
    fprintf ( fp_dest, "tios::%s    \tequ\t_ROM_CALL_%X\n", Buffer, fct_num/4 );
    fprintf ( fp_dest, "romfunc::%s \tequ\t_ROM_CALL_%X\n\n", Buffer, fct_num/4 );

  }  while ( ( r != EOF ) );

  fclose ( fp_dest );
  fclose ( fp_src );

  return 0;
}
//---------------------------------------------------------------------------
